import es, playerlib, popuplib, gamethread

admin_list = ['STEAM_0:1:8592283','STEAM_0:0','STEAM_0:1']

info = es.AddonInfo()
info['name'] = "Teleport To Player"
info['basename'] = "teleport_to_player"
info['version'] = "1.0"
info['author'] = "Undead"
info['url'] = ""
info['description'] = "Allows admins to teleport a selected player"

es.ServerVar(info['basename'], info['version'], info['description']).makepublic()

def load():
  if not es.exists('saycommand', '!teleport'):
    es.regsaycmd('!teleport', 'teleport_to_player/teleport_cmd')

def teleport_cmd():
  userid = es.getcmduserid()
  if es.getplayersteamid(userid) in admin_list:
    target_list = popuplib.construct('target_list', 'players', '#alive', target_list_select)
    target_list.settitle("Select a Player to Teleport to")
    popuplib.send('target_list', userid)

def target_list_select(userid, choice, popupid):
  x,y,z = es.getplayerlocation(choice)
  es.server.queuecmd('es_setpos %s %s %s %s'%(int(userid), x,y,z))
  playerlib.getPlayer(int(userid)).set('noblock','1')
  playerlib.getPlayer(int(choice)).set('noblock','1')
  gamethread.delayed(5, unblock_player, (userid, choice))
  popuplib.delete('target_list')

def unblock_player(userid, choice):
  playerlib.getPlayer(int(choice)).set('noblock','0')
  playerlib.getPlayer(int(userid)).set('noblock','0')

def unload():
  if es.exists('saycommand', '!teleport'):
    es.unregsaycmd('!teleport')